#include "base.h"

#include <QtDebug>

Base baseFactory()
   {
   Base result;
   result._string = "factorized";
   return result;
   }

int main(int , char *[])
   {
   qDebug() << "\ncreate simple base";
   Base myBase1;

   qDebug() << "\ncreate base by factory and assign";
   Base myBase2 = baseFactory();

   qDebug() << "\ncreate base by factory copy constructor";
   Base myBase3(baseFactory());

   qDebug() << "\nget string from simple base";
   QString string1 = myBase1.string();

   qDebug() << "\nget string from factory result";
   QString string2 = baseFactory().string();

   qDebug() << "\ndebug output string from simple base";
   qDebug() << myBase1.string();

   qDebug() << "\ndebug output string from factory result";
   qDebug() << baseFactory().string();

   return 0;
   }
